
/*
 * Copyright (C) 1998,1999  Thomas Mirlacher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * The author may be reached as dent@cosy.sbg.ac.at, or
 * Thomas Mirlacher, Jakob-Haringerstr. 2, A-5020 Salzburg,
 * Austria
 *
 *------------------------------------------------------------
 *
 */


#ifdef PARSER
#include <stdio.h>
#endif
#include <sys/types.h>
#include <unistd.h>
#include "ifo.h"

#include "misc.h"
#include "decode.h"

#define TMT_SUB_LEN 4


/**
 *
 */

void ifo_print_toast (u_char *ptr)
{
	ifo_hdr_t *hdr = (ifo_hdr_t *) ptr;
	int i;

	if (!ptr)
		return;

	printf ("TOAST TABLE\n");
	printf ("---\n");
	printf ("number of maps: %d\n", ntohs (hdr->num));	
	printf ("length of table: %d\n", ntohl (hdr->len));	

	ptr += IFO_HDR_LEN;

	for (i=0; i<ntohs (hdr->num); i++) {
		printf ("%08x %08x %08x\n",
			get4bytes (ptr+=4),
			get4bytes (ptr+=4),
			get4bytes (ptr+=4));
	}
}	
